#include "KlappenAblauf.h"



KlappenAblauf::~KlappenAblauf()
{
}


void KlappenAblauf::setOpen(bool open)
{
  openSpeicher = open;


}

void  KlappenAblauf::setOpen(bool open , int id)
{ 
  KlappenAblauf *zeiger;
  zeiger = (KlappenAblauf *) searchIdElement(id);
  if(zeiger)
    return zeiger->setOpen(open);
}

void KlappenAblauf::memberSetup(){
  
  AnalogDigital::memberSetup();
  openSpeicher = false;
  fsmInit();
}

void KlappenAblauf::memberLoop(){
  AnalogDigital::memberLoop();
  openSpeicherAbfrage();
  fsmStep();
}

void KlappenAblauf::fsmInit(){
  aktuellerState = INIT;
    


}

void KlappenAblauf::openSpeicherAbfrage(){
  if(openSpeicher){
    if(aktuellerState == WARTE_GESCHLOSSEN){
      aktuellerState = START_AUF;
    }
  }else{
    if(aktuellerState == WARTE_OFFEN){
        aktuellerState = START_ZU;
    }
  }

}



void KlappenAblauf::fsmStep(){

  switch (aktuellerState)
  {
  case INIT:
    aktuellerState = REF_FAHRT;
    setOpen(false);
    break;

  case REF_FAHRT:
    timer = 5000;
    setSollSpeed(LANGSAMME_FAHRT);
    aktuellerState = FAEHRT_AUF_LANGSAM;
    break;  

  case WARTE_OFFEN:
  case WARTE_GESCHLOSSEN:
    break;

  case START_AUF:
    setSollSpeed(SCHNELLE_FAHRT);
    timer = 1800;
    aktuellerState = FAEHRT_AUF_SCHNELL;
    break;

  case START_ZU:
    setSollSpeed(-SCHNELLE_FAHRT);
    timer = 1800;
    aktuellerState = FAEHRT_ZU_SCHNELL;
    break;

  case FAEHRT_AUF_SCHNELL:
    timer -= getDeltamsec();
    if(timer <= 0){
      timer = 2000;
      setSollSpeed(LANGSAMME_FAHRT);
      aktuellerState = FAEHRT_AUF_LANGSAM;
    }
    break;

  case FAEHRT_AUF_LANGSAM:
    timer -= getDeltamsec();
    if(timer <= 0){
      setSollSpeed(0);
      aktuellerState = WARTE_OFFEN;
    }
    break;

  case FAEHRT_ZU_SCHNELL:
    timer -= getDeltamsec();
    if(timer <= 0){
      timer = 2000;
      setSollSpeed(-LANGSAMME_FAHRT);
      aktuellerState = FAEHRT_ZU_LANGSAM;
    }
    break;

  case FAEHRT_ZU_LANGSAM:
    timer -= getDeltamsec();
    if(timer <= 0){
      setSollSpeed(0);
      aktuellerState = WARTE_GESCHLOSSEN;
    }
    break;

  default:
    aktuellerState = INIT;
    break;
  }

}
