#include "motor.h"




  uint8_t Motor::pinPwm;



void Motor::setMotorPins(uint8_t pinA , uint8_t pinB){
  this->pinA = pinA;
  this->pinB = pinB;
}

void Motor::setMotorPwmPin(uint8_t pinPwm){
  Motor::pinPwm = pinPwm;
}



void Motor::setup(){
  ArduinoAnpassung::setup();
  Timer1.initialize(100);     //10kHz
  pinMode(pinPwm , OUTPUT);
  digitalWrite(pinPwm , 1);
  Timer1.attachInterrupt(Motor::interruptEinsprung);
}

void Motor::interruptEinsprung(){
  MyList *zeiger;
  zeiger =  ArduinoAnpassung::getErstesElement();
  while(zeiger){
    ((Motor*)zeiger)->memberInterruptEinsprung();
    zeiger = zeiger->getNachfolgerElement();
  }
}

  void Motor::memberInterruptEinsprung(){
  interruptBerechnungen();
}

void Motor::interruptBerechnungen(){
  /*if(sollSpeed > istSpeed){
    istSpeed++;
    setIstSpeed(istSpeed);
  }
  if(sollSpeed < istSpeed){
    istSpeed --;
    setIstSpeed(istSpeed);
  }*/
  
  istSpeed = sollSpeed;


  summeSpeed += istSpeed;
  if(summeSpeed >= 256)
  {
    summeSpeed -= 256;
    digitalWrite(pinA , 1);
    digitalWrite(pinB , 0);

  }else if (summeSpeed <= -256){
    summeSpeed += 256;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 1);

  }else{
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 0);

  }

  

}




void Motor::setSollSpeed(int16_t speed){
  

  if(speed > 256)
    speed = 256;
  if(speed < -256)
    speed = -256;

  sollSpeed = speed;

}






void Motor::memberSetup(){
  pinMode(pinA , OUTPUT);
  digitalWrite( pinA , 0);

  pinMode(pinB , OUTPUT);
  digitalWrite(pinB , 0);
}






